#include <LiquidCrystal.h>
int spannungswerte[7][7];
int abgefragt[7][7];
int aktFeldx; // x Position des Feldes, das aktuell überprüft werden soll
int aktFeldy; // y Position des Feldes, das aktuell überprüft werden soll
int tasterEingabe = 51; //Pinnummer für den Eingabeknopf wird zwischengespeichert
int tasterStatusEingabe = LOW; //Das Wort „tasterstatus“ steht jetzt zunächst für den Wert 0. Später wird unter dieser Variable gespeichert, ob der Taster gedrückt ist oder nicht.
int gelbeLampePin = 46;
int roteLampePin = 48;
int blaueLampePin = 47;
boolean wasser = false; 
boolean treffer = false;
bool linksAbgeschlossen = false;
bool obenAbgeschlossen = false;
bool rechtsAbgeschlossen = false;
bool untenAbgeschlossen = false;
int blinkdauer = 300;
LiquidCrystal lcd(37, 38, 39, 40, 41, 42);
int botAsked[7][7];
int waterPin = A5;
int hitPin = A6;
int sunkPin = A7;
int shipsSunk[3]; // hier wird gespeichert, welche Schiffe vom Spieler schon versenkt sind

// Multiplexer 1 (digitale Pins am Arduino)
int pin10 = 22;   //S2
int pin11 = 23;   //S1
int pin12 = 24;   //S0
//Multiplexer 2
int pin20 = 25;   //S2
int pin21 = 26;   //S1
int pin22 = 27;   //S0
//Multiplexer 3
int pin30 = 28;   //S2
int pin31 = 29;   //S1
int pin32 = 30;   //S0
//Multiplexer 4
int pin40 = 31;   //S2
int pin41 = 32;   //S1
int pin42 = 33;   //S0
//Multiplexer 5
int pin50 = 34;   //S2
int pin51 = 35;   //S1
int pin52 = 36;   //S0


int board[7][7];
int amountTrys = 0; // Zugzähler
typedef struct ship { // lege Datentyp Schiff an
  int len;
  bool isVertical;
  int x;
  int y;
}ship;

int createBoard(int board[7][7]) { // Lege ein 5*5 Spielbrett an
  for (int i = 0; i <= 5 + 1; i++) {
    for (int j = 0; j <= 5 + 1; j++) {
      board[i][j] = false; // fülle jedes Feld mit false
    }
  } return board;
}

ship setShip(int len) { // Schiffe der Länge len platzieren auf einem 5*5 Spielbrett
  // ermittle Variablen
  int x, y;
  bool vertical = random(0, 2); // zufällig zwischen false und true
  // bei random() muss man immer dem Maximalwert um 1 erhöht eingeben
  if (vertical == false) { // prüfe vor der Vergabe der Koordinaten ob das Schiff vertikal ist
    x = random(1, 6);   // zufällig zwischen 1 und 6 minus die Länge
    y = random(1, 7 - len); // zufällig zwischen 1 und 6 minus die Länge
  } else {
    x = random(1, 7 - len); // zufällig zwischen 1 und 6 minus die Länge
    y = random(1, 6);   // zufällig zwischen 1 und 6 minus die Länge
  }
  ship s = {len, vertical, x, y}; // erstelle Schiff
  //  Serial.print("Ship Length: "+String(s.len)+", isVertical: "+String(s.isVertical)); // debug
  //  Serial.print(", xPos: "+String(s.x) +", yPos: "+ String(s.y));
  //  Serial.println();
  if (isFree(s) && !s.isVertical) {
    for (int i = 0; i < s.len; i++) {
      board[x][y + i] = true;
    }
  } else if (isFree(s) && s.isVertical) {
    for (int i = 0; i < s.len; i++) {
      board[x + i][y] = true;
    }
  } else {
    setShip(len); // wenn die gewählten Koordinaten besetzt sind, führe setShip noch einmal aus
  }
  return s;
}
// überprüfe ob der Bereich, wo ein Schiff platziert werden soll, frei ist
bool isFree(ship s) {
  if (board[s.x][s.y] == true) {
    return false; // wenn der Ursprungspunkt belegt ist, dann gebe false zurück
  }
  if (s.len == 1) { // für ein Schiff mit der Länge 1
    if (board[s.x][s.y - 1] == false &&
        board[s.x - 1][s.y] == false && board[s.x + 1][s.y] == false &&
        board[s.x][s.y + 1] == false) {
      return true; // wenn der Bereich um ein 1er Schiff frei ist, dann gebe true zurück
    }
  } // überprüfung für Schiffe der länge 1 abgeschlossen
  if (board[s.x + 1][s.y] == true && board[s.x][s.y + 1] == true) {
    return false; // wenn der zweite Punkt des Schiffs belegt ist, dann gebe false zurück
  }
  if (s.len == 2 && !s.isVertical) {
    if (board[s.x][s.y - 1] == false &&
        board[s.x + 1][s.y] == false && board[s.x - 1][s.y] == false &&
        board[s.x + 1][s.y + 1] == false && board[s.x - 1][s.y + 1] == false &&
        board[s.x][s.y + 2] == false) {
      return true; // wenn der Bereich um ein vertikales 2er Schiff frei ist, dann gebe true zurück.
    }

  }
  if (s.len == 2 && s.isVertical) {
    if (board[s.x - 1][s.y] == false &&
        board[s.x][s.y + 1] == false && board[s.x][s.y - 1] == false &&
        board[s.x + 1][s.y + 1] == false && board[s.x + 1][s.y - 1] == false &&
        board[s.x + 2][s.y] == false) {
      return true; // wenn der Bereich um ein horizontales 2er Schiff frei ist, dann gebe true zurück.
    }
  } // Überprüfung für Schiffe der Länge 2 abgeschlossen
  if (board[s.x + 2][s.y] == true && board[s.x][s.y + 2] == true) {
    return false; // wenn der dritte Punkt des Schiffs belegt ist, dann gebe false zurück
  }
  if (s.len == 3 && !s.isVertical) {
    if (board[s.x][s.y - 1] == false &&
        board[s.x + 1][s.y] == false && board[s.x - 1][s.y] == false &&
        board[s.x + 1][s.y + 1] == false && board[s.x - 1][s.y + 1] == false &&
        board[s.x + 1][s.y + 2] == false && board[s.x - 1][s.y + 2] == false &&
        board[s.x][s.y + 3] == false) {
      return true; // wenn der Bereich um ein vertikales 2er Schiff frei ist, dann gebe true zurück.
    }

  }
  if (s.len == 3 && s.isVertical) {
    if (board[s.x - 1][s.y] == false &&
        board[s.x][s.y + 1] == false && board[s.x][s.y - 1] == false &&
        board[s.x + 1][s.y + 1] == false && board[s.x + 1][s.y - 1] == false &&
        board[s.x + 2][s.y + 1] == false && board[s.x + 2][s.y - 1] == false &&
        board[s.x + 3][s.y] == false) {
      return true; // wenn der Bereich um ein horizontales 2er Schiff frei ist, dann gebe true zurück.
    }
  } // Überprüfung für Schiffe der Länge 3 abgeschlossen

  return false; // gebe false zurück, wenn die Felder belegt sind

}
void spannungswerteSpeichern() {
  spannungswerteAuslesen(pin12, pin11, pin10, A0, 1);
  spannungswerteAuslesen(pin22, pin21, pin20, A1, 2);
  spannungswerteAuslesen(pin32, pin31, pin30, A2, 3);
  spannungswerteAuslesen(pin42, pin41, pin40, A3, 4);
  spannungswerteAuslesen(pin52, pin51, pin50, A4, 5);
}


void spannungswerteAuslesen(int pin1, int pin2, int pin3, int analogPin, int spalte) {
  digitalWrite(pin1, LOW);      //Pin A
  digitalWrite(pin2, LOW);
  digitalWrite(pin3, LOW);
  spannungswerte[1][spalte] = analogRead(analogPin);

  digitalWrite(pin1, LOW);      //Pin B
  digitalWrite(pin2, LOW);
  digitalWrite(pin3, HIGH);
  spannungswerte[2][spalte] = analogRead(analogPin);

  digitalWrite(pin1, LOW);      //Pin C
  digitalWrite(pin2, HIGH);
  digitalWrite(pin3, LOW);
  spannungswerte[3][spalte] = analogRead(analogPin);

  digitalWrite(pin1, LOW);      //Pin D
  digitalWrite(pin2, HIGH);
  digitalWrite(pin3, HIGH);
  spannungswerte[4][spalte] = analogRead(analogPin);

  digitalWrite(pin1, HIGH);      //Pin E
  digitalWrite(pin2, LOW);
  digitalWrite(pin3, LOW);
  spannungswerte[5][spalte] = analogRead(analogPin);
}


void aktFeld() { //ermittelt Position des Feldes, das abgefragt werden soll, bzw. wo der Spielstein gesetzt wurde
  int niedrigsterSpannungswert = 1024;      //Variable zum Ermitteln des niedrigsten Spannungswertes
  for (int i = 1; i <= 5; i++) { 
    for (int j = 1; j <= 5; j++) { 
      if (abgefragt[i][j] == false) { //wenn das Feld noch nicht abgefragt wurde, wird überprüft, ob der Spannungswert niedriger ist als die vorher überprüften Spannungswerte
        if (spannungswerte[j][i] < niedrigsterSpannungswert) {
          aktFeldx = i;
          aktFeldy = j;
          niedrigsterSpannungswert = spannungswerte[j][i];
        }
      }
    }
  }
}

void checkShip() { //prüft ob neben dem aktuellen Feld Wasser oder ein Schiff ist und ob das Schiff versenkt wurde -> Lampen werden angeschaltet
  if (board[aktFeldx][aktFeldy] == true) {
    Serial.println("akt Feld true");
    abgefragt[aktFeldx][aktFeldy] = 2; // setze abgefragt für das aktuelle Feld auf Treffer
    linksAbgeschlossen = true;
    rechtsAbgeschlossen = true;
    obenAbgeschlossen = true;
    untenAbgeschlossen = true;
    if (board[aktFeldx - 1][aktFeldy] == true) { // links
      Serial.println("linkes feld true");
      linksAbgeschlossen = false;
      if (abgefragt[aktFeldx - 1][aktFeldy] >= 1) {
        Serial.println("linkes feld bereits abgefragt");
        linksAbgeschlossen = true;
        if (board[aktFeldx - 2][aktFeldy] == true) {
          Serial.println("2 linkes feld true");
          linksAbgeschlossen = false;
          if (abgefragt[aktFeldx - 2][aktFeldy] >= 1) {
            Serial.println("2 linkes feld abgefragt, versenkt");
            linksAbgeschlossen = true;
          }
        }
      }
    } treffer = true;
    if (board[aktFeldx + 1][aktFeldy] == true) {
      Serial.println("rechtes feld true");
      rechtsAbgeschlossen = false;
      if (abgefragt[aktFeldx + 1][aktFeldy] >= 1) {
        Serial.println("rechtes feld bereits abgefragt");
        rechtsAbgeschlossen = true;
        if (board[aktFeldx + 2][aktFeldy] == true) {
          Serial.println("2 rechtes feld true");
          rechtsAbgeschlossen = false;
          if (abgefragt[aktFeldx + 2][aktFeldy] >= 1) {
            Serial.println("2 rechtes feld abgefragt, versenkt");
            rechtsAbgeschlossen = true;
          }
        }
      }
    } treffer = true;
    if (board[aktFeldx][aktFeldy - 1] == true) {
      Serial.println("oberes feld true");
      obenAbgeschlossen = false;
      if (abgefragt[aktFeldx][aktFeldy - 1] >= 1) {
        Serial.println("oberes feld bereits abgefragt");
        obenAbgeschlossen = true;
        if (board[aktFeldx][aktFeldy - 2] == true) {
          Serial.println("2 oberes feld true");
          obenAbgeschlossen = false;
          if (abgefragt[aktFeldx][aktFeldy - 2] >= 1) {
            Serial.println("2 oberes feld abgefragt, versenkt");
            obenAbgeschlossen = true;
          }
        }
      }
    }
    treffer = true;
    if (board[aktFeldx][aktFeldy + 1] == true) {
      Serial.println("unten feld true");
      untenAbgeschlossen = false;
      if (abgefragt[aktFeldx][aktFeldy + 1] >= 1) {
        Serial.println("unten feld bereits abgefragt");
        untenAbgeschlossen = true;
        if (board[aktFeldx][aktFeldy + 2] == true) {
          Serial.println("2 unten feld true");
          untenAbgeschlossen = false;
          if (abgefragt[aktFeldx][aktFeldy + 2] >= 1) {
            Serial.println("2 unten feld abgefragt, versenkt");
            untenAbgeschlossen = true;
          }
        }
      }
    }
    treffer = true;
  } else if (board[aktFeldx][aktFeldy] == false) {
    wasser = true;
    abgefragt[aktFeldx][aktFeldy] = 1; // setze abgefragt für das aktuelle Feld auf Wasser
  }
}

void gelbeLampe() {
  digitalWrite(gelbeLampePin, HIGH);
  Serial.println("gelb leuchtet");
}

void roteLampe() {
  digitalWrite(roteLampePin, HIGH);
  Serial.println("rot leuchtet");
}
void blaueLampe() {
  digitalWrite(blaueLampePin, HIGH);
  Serial.println("blau leuchtet");
}
// gibt einen Buchstaben für die Zahlen 1 - 5 zurück
char getLetterFromX(int x) {
  if (x == 1) return 'A';
  if (x == 2) return 'B';
  if (x == 3) return 'C';
  if (x == 4) return 'D';
  if (x == 5) return 'E';
}
void check() { //prüft alle Felder um das aktuelle Feld herum
  spannungswerteSpeichern();
  aktFeld();
  Serial.println("aufgerufendes Feld: " + String(aktFeldx) + ", " + String(aktFeldy));
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Du raetst: ");
  lcd.setCursor(0, 1);
  lcd.print(getLetterFromX(aktFeldy) + String(aktFeldx) + " ->");
  lcd.setCursor(6, 1);
  wasser = false;               //Variablen auf false zurücksetzen
  treffer = false;
  linksAbgeschlossen = false;
  rechtsAbgeschlossen = false;
  obenAbgeschlossen = false;
  untenAbgeschlossen = false;
  //Serial.println(aktFeldx);
  //Serial.println(aktFeldy);
  checkShip();
  if (treffer == true) {
    if (linksAbgeschlossen == true && obenAbgeschlossen == true && rechtsAbgeschlossen == true && untenAbgeschlossen == true) {
      roteLampe();
      lcd.print("Versenkt");
      // setze alle als getroffen markierten Felder zu Versenkt
      int i = aktFeldx;
      while (abgefragt[i][aktFeldy] == 2) { // setze alle Treffer zu versenkt in Richtung -x
        abgefragt[i][aktFeldy] = 3;
        if (abgefragt[i - 1][aktFeldy] == 0)  // setze alle umliegenden Felder zu wasser,
          abgefragt[i - 1][aktFeldy] = 1;     // falls sie noch nicht abgefragt sind
        if (abgefragt[i + 1][aktFeldy] == 0)
          abgefragt[i + 1][aktFeldy] = 1;
        if (abgefragt[i][aktFeldy - 1] == 0)
          abgefragt[i][aktFeldy - 1] = 1;
        if (abgefragt[i][aktFeldy + 1] == 0)
          abgefragt[i][aktFeldy + 1] = 1;
        i --;
      } i = aktFeldx + 1;
      while (abgefragt[i][aktFeldy] == 2) { // setze alle Treffer zu versenkt in Richtung +x
        abgefragt[i][aktFeldy] = 3;
        if (abgefragt[i - 1][aktFeldy] == 0)  // setze alle umliegenden Felder zu wasser,
          abgefragt[i - 1][aktFeldy] = 1;     // falls sie noch nicht abgefragt sind
        if (abgefragt[i + 1][aktFeldy] == 0)
          abgefragt[i + 1][aktFeldy] = 1;
        if (abgefragt[i][aktFeldy - 1] == 0)
          abgefragt[i][aktFeldy - 1] = 1;
        if (abgefragt[i][aktFeldy + 1] == 0)
          abgefragt[i][aktFeldy + 1] = 1;
        i ++;
      } i = aktFeldy - 1;
      while (abgefragt[aktFeldx][i] == 2) { // setze alle Treffer zu versenkt in Richtung -y
        abgefragt[aktFeldx][i] = 3;
        if (abgefragt[aktFeldx - 1][i] == 0)  // setze alle umliegenden Felder zu wasser,
          abgefragt[aktFeldx - 1][i] = 1;     // falls sie noch nicht abgefragt sind
        if (abgefragt[aktFeldx + 1][i] == 0)
          abgefragt[aktFeldx + 1][i] = 1;
        if (abgefragt[aktFeldx][i - 1] == 0)
          abgefragt[aktFeldx][i - 1] = 1;
        if (abgefragt[aktFeldx][i + 1] == 0)
          abgefragt[aktFeldx][i + 1] = 1;
        i --;
      } i = aktFeldy + 1;
      while (abgefragt[aktFeldx][i] == 2) { // setze alle Treffer zu versenkt in Richtung +y
        abgefragt[aktFeldx][i] = 3;
        if (abgefragt[aktFeldx - 1][i] == 0)  // setze alle umliegenden Felder zu wasser,
          abgefragt[aktFeldx - 1][i] = 1;     // falls sie noch nicht abgefragt sind
        if (abgefragt[aktFeldx + 1][i] == 0)
          abgefragt[aktFeldx + 1][i] = 1;
        if (abgefragt[aktFeldx][i - 1] == 0)
          abgefragt[aktFeldx][i - 1] = 1;
        if (abgefragt[aktFeldx][i + 1] == 0)
          abgefragt[aktFeldx][i + 1] = 1;
        i ++;
      }
    }
    else {
      gelbeLampe();
      lcd.print("Treffer");
    }
  }
  if (wasser == true) {
    blaueLampe();
    lcd.print("Wasser");
  }
  delay(2048);
}

boolean alleSchiffeVersenkt() {
  for (int l = 1; l <= 5; l++) {
    for (int m = 1; m <= 5; m++) {
      if (board[l][m] == true) {
        if (abgefragt[l][m] == false) {
          return false;
        }
      }
    }
  }
  return true;
}
// setze alle getroffenden Schiffe des Spielers zu Versenkt und speichere es in shipsSunk
void setToSunk(int botAsked[7][7], int field[2], int fields[4][2]) {
  for (int i = 1; i < 6; i++) {
    for (int j = 1; j < 6; j++) {
      if (botAsked[i][j] == 2) {  // markiere alle Treffer als versenkt
        botAsked[i][j] = 3;
        if (botAsked[i - 1][j] == 0)
          botAsked[i - 1][j] = 1;  // und die Felder außenrum als Wasser
        if (botAsked[i + 1][j] == 0)
          botAsked[i + 1][j] = 1;
        if (botAsked[i][j - 1] == 0)
          botAsked[i][j - 1] = 1;
        if (botAsked[i][j + 1] == 0)
          botAsked[i][j + 1] = 1;
      }
    }
  } int k = 0;
  for (k; fields[k][0] != 0; k++) ; // ermittle die Länge des Schiffes
  shipsSunk[k] ++; // füge das Schiff zur Liste der versenkten schiffe hinzu
  Serial.println("[VERSENKT]");
  lcd.setCursor(3, 1);
  lcd.print("Versenkt");
  Serial.println("Versenkte Schiffe: ");
  Serial.println(String(shipsSunk[0]) + " 1er, " + String(shipsSunk[1]) + " 2er, " + String(shipsSunk[2]) + " 3er, ");
  return;
}
// setzte je nach Antwort des Spielers die Schiffe zu Wasser, Treffer oder Versenkt
void setValue(int botAsked[7][7], int field[2], int fields[4][2], bool hit) {
  // falls keine Eingabe existiert, dann ist vor und hinter dem als getroffen markierten Schiff Wasser
  // dann ist es versenkt
  if (field[0] == 0 || field[1] == 0) {
    int k = 0;
    Serial.println("[Alles getroffen] -> [VERSENKT]");
    setToSunk(botAsked, field, fields);
    return botMove(botAsked);
  }
  while (true) { // warte auf Eingabe ...
    if (analogRead(waterPin) > 600) {
      botAsked[field[0]][field[1]] = 1; // setze das Feld zu Wasser
      lcd.setCursor(3, 1);
      Serial.println("[WASSER]");
      lcd.print("Wasser");
      hit = false;
      return;
    }
    if (analogRead(hitPin) > 600) {
      botAsked[field[0]][field[1]] = 2; // setze das Feld zu Treffer
      Serial.println("[TREFFER]");
      lcd.setCursor(3, 1);
      lcd.print("Treffer");
      hit = true;
      return;
    }
    if (analogRead(sunkPin) > 600) {
      botAsked[field[0]][field[1]] = 2; // setze das Feld zu Versenkt
      return setToSunk(botAsked, field, fields);
    }
  }
}
// fügt Feld zur Auswahl hinzu, falls der Bot da noch nicht geraten hat
void addField(int unaskedFields[4][2], int fields[4][2], int x, int y, int k, int l) {
  if (fields[k][0] + x < 1 || fields[k][0] + x > 5 ||
      fields[k][1] + y < 1 || fields[k][1] + y > 5) { // überprüfe ob das Feld in dem Spielbrett liegt
    Serial.print(String(fields[k][0] + x) + " " + String(fields[k][1] + y) + "n; ");
    return; // wenn nicht füge es nicht hinzu
  }
  if (botAsked[fields[k][0] + x][fields[k][1] + y] == 0) { // überprüfe ob das Feld schon abgefragt wurde
    l++;
    unaskedFields[l][0] = fields[k][0] + x; // falls ja, füge es hinzu
    unaskedFields[l][1] = fields[k][1] + y;
    Serial.print(String(fields[k][0] + x) + " " + String(fields[k][1] + y) + "y; ");
  } else Serial.print(String(fields[k][0] + x) + " " + String(fields[k][1] + y) + "N; ");
}
// findet alle Treffer im botAsked Array
void getHitShip(int botAsked[7][7], int fields[4][2]) {
  for (int i = 0; i < 3; i++) {
    fields[i][0] = 0;
    fields[i][1] = 0;
  }
  int k = 0;
  Serial.println("gefundene Schiffe");
  for (int i = 1; i < 6; i++) {
      for (int j = 1; j < 6; j++) {
      if (botAsked[i][j] == 2) {
        fields[k][0] = i;
        fields[k][1] = j;
        Serial.print(String(i) + " " + String(j) + "; ");
        k++;
      }
    }
  } Serial.println();
  return;
}

void sunkHandler(int botAsked[7][7], int fields[4][2], bool hit) {
  Serial.println("erkenne versenkte Schiffe:");
  if (shipsSunk[2] == 0) { // wenn noch kein dreier versenkt ist ...
  Serial.print("Kein dreier versenkt > ");
    if (botAsked[fields[0][0]][fields[0][1]] == 2 && botAsked[fields[1][0]][fields[1][1]]) {
      // ... und drei Felder hintereinender auf treffer gesetzt sind ...
      if (botAsked[fields[0][0]][fields[0][1] - 1] == 2 || botAsked[fields[1][0]][fields[1][1] + 1] == 2 ||
          botAsked[fields[0][0] - 1][fields[0][1]] == 2 || botAsked[fields[1][0] + 1][fields[1][1]] == 2) {
        Serial.println("versenke Schiff auf " + String(fields[0][0]) + " " + String(fields[0][1]));
        setToSunk(botAsked, fields[0], fields); // ... dann markiere es als versenkt
      }
    }
  } else if (shipsSunk[1] == 0) { // wenn noch ein dreier und kein zweier versenkt ist ...
    Serial.print("ein dreier und kein zweier versenkt > ");
    if (botAsked[fields[0][0]][fields[0][1]] == 2) {
      // ... und zwei Felder hintereinender auf treffer gesetzt sind ...
      if (botAsked[fields[0][0]][fields[0][1] - 1] == 2 || botAsked[fields[0][0]][fields[1][1] + 1] == 2 ||
          botAsked[fields[0][0] - 1][fields[0][1]] == 2 || botAsked[fields[0][0] + 1][fields[1][1]] == 2) {
        Serial.println("versenke Schiff auf " + String(fields[0][0]) + " " + String(fields[0][1]));
        setToSunk(botAsked, fields[0], fields); // ... dann markiere es als versenkt
      }
    }
  } // einser werden woanders überprüft
}
// steuert das Abfragen vom Roboter
void botMove(int botAsked[7][7]) {
  bool hit;
  int fields[4][2]; // Felder von bereits getroffenden Schiffen
  getHitShip(botAsked, fields);
  if (fields[0][0] == 0 || fields[0][1] == 0) { // falls noch nichts getroffen wurde
    int field[] = { random(1, 6), random(1, 6) }; // rate zufällig
    // generiere solange neu, bis die Felder noch nicht abgefragt sind
    while (botAsked[field[0]][field[1]] != 0) {
      field[0] = random(1, 6);
      field[1] = random(1, 6);
    }
    Serial.println(
      "[RANDOM] Bot fragt: " + String(field[0]) + ", "
      + String(field[1]));
    lcd.clear();
    lcd.setCursor(0, 0);
    String out = "Bot raet: " + String(getLetterFromX(field[0])) + String(field[1]);
    lcd.print(out);
    lcd.setCursor(0, 1);
    lcd.print("->");
    setValue(botAsked, field, fields, hit);
    /* falls es ein treffer ist und alle zweier und dreier versenkt sind
     * markiere den einser sofort als versenkt
     */
    if (botAsked[field[0]][field[1]] == 2 && shipsSunk[2] > 0 && shipsSunk[1] > 0) {
      Serial.print("[Letzte 1er]");
      setToSunk(botAsked, fields[0], fields);
    }
    return;
  }
  // suche alle nicht-abgefragten Felder neben getroffenen Schiffen
  Serial.println("nicht-abgefragte Felder");
  int k = 0; // laufvar: geht durch alle getroffenden schiffe
  int unaskedFields[4][2] = { { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 }};
  // index der nicht-abgefragten Felder: -1 heißt: es existieren keine
  int indexUnaskedFields = -1;
  if (fields[1][0] == 0) { // 1er
    Serial.print("1er,"); // für einser in alle Richtungen
    addField(unaskedFields, fields, -1, 0, k, indexUnaskedFields); // -x
    addField(unaskedFields, fields, 1, 0, k, indexUnaskedFields);  // +x
    addField(unaskedFields, fields, 0, 1, k, indexUnaskedFields);  // -y
    addField(unaskedFields, fields, 0, -1, k, indexUnaskedFields); // +y
  } if (fields[0][1] == fields[1][1]) {
    Serial.print("vertikal:"); // für vertikale Schiffe
    addField(unaskedFields, fields, -1, 0, k, indexUnaskedFields); // -x
    addField(unaskedFields, fields, 1, 0, k, indexUnaskedFields);  // +x
  } if (fields[0][0] == fields[1][0]) {
    Serial.print("horizontal:"); // für horizontale Schiffe
    addField(unaskedFields, fields, 0, -1, k, indexUnaskedFields); // -y
    addField(unaskedFields, fields, 0, 1, k, indexUnaskedFields);  // +y
  }
  while (k < 4 && fields[k + 1][0] != 0 && fields[k + 1][1] != 0) {
    k++; // gehe bis zum Ende eines Schiffes
  }
  if (fields[0][0] == fields[1][0]) { 
    addField(unaskedFields, fields, 0, 1, k, indexUnaskedFields); // +y
    addField(unaskedFields, fields, 0, -1, k, indexUnaskedFields); // -y
  } else if (fields[0][1] == fields[1][1]) { 
    addField(unaskedFields, fields, 1, 0, k, indexUnaskedFields); // +x
    addField(unaskedFields, fields, -1, 0, k, indexUnaskedFields); // +x
  }
  Serial.println();
  int r = random(0, indexUnaskedFields + 1); // suche aus den nicht-abgefragten Feldern eins zufällig aus
  Serial.println(
    "[CONTINUE] Bot fragt: " + String(unaskedFields[r][0]) + ", "
    + String(unaskedFields[r][1]));
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Bot raet: " + String(getLetterFromX(unaskedFields[r][0])) + String(unaskedFields[r][1]));
  lcd.setCursor(0, 1);
  lcd.print("->");
  setValue(botAsked, unaskedFields[r], fields, hit);
  sunkHandler(botAsked, fields, hit);
}

void setup() {
  Serial.begin(9600);
  pinMode(pin12, OUTPUT);
  pinMode(pin11, OUTPUT);
  pinMode(pin10, OUTPUT);

  pinMode(pin22, OUTPUT);
  pinMode(pin21, OUTPUT);
  pinMode(pin20, OUTPUT);

  pinMode(pin32, OUTPUT);
  pinMode(pin31, OUTPUT);
  pinMode(pin30, OUTPUT);

  pinMode(pin42, OUTPUT);
  pinMode(pin41, OUTPUT);
  pinMode(pin40, OUTPUT);

  pinMode(pin52, OUTPUT);
  pinMode(pin51, OUTPUT);
  pinMode(pin50, OUTPUT);
  pinMode(tasterEingabe, INPUT);
  pinMode(gelbeLampe, OUTPUT);
  pinMode(roteLampe, OUTPUT);
  pinMode(blaueLampe, OUTPUT);
  randomSeed(analogRead(2));  //zufällige random Ergebnisse
  
  // gebe den bootTitle aus
  Serial.println(" _____      _     _  __  __       _   _                          _              "); 
  Serial.println("/  ___|    | |   (_)/ _|/ _|     | | | |                        | |             ");
  Serial.println("\\ `--.  ___| |__  _| |_| |_ ___  | | | | ___ _ __ ___  ___ _ __ | | _____ _ __  ");
  Serial.println(" `--. \\/ __| '_ \\| |  _|  _/ _ \\ | | | |/ _ \\ '__/ __|/ _ \\ '_ \\| |/ / _ \\ '_ \\ ");
  Serial.println("/\\__/ / (__| | | | | | | ||  __/ \\ \\_/ /  __/ |  \\__ \\  __/ | | |   <  __/ | | |");
  Serial.println("\\____/ \\___|_| |_|_|_| |_| \\___|  \\___/ \\___|_|  |___/\\___|_| |_|_|\\_\\___|_| |_|");
  Serial.println("© Alice, Jan, Jonis & Lisa");
  Serial.println("================================================================================");
  Serial.println("Hallo! ");
  Serial.println("");
  Serial.println("");
  // init lcd
  lcd.display();
  lcd.begin(16, 2);
  lcd.print("SchiffeVersenken");
  lcd.setCursor(0, 1);
  lcd.print("Hallo");
  createBoard(board); // erstelle Brett des Roboters
  createBoard(botAsked);
  
  // platziere Schiffe
  ship ships[4];
  ships[0] = setShip(3);
  ships[1] = setShip(2);
  ships[2] = setShip(1);
  ships[3] = setShip(1);
  
  //* // debug (cheat-mode) <lösche ein "/" um das auszukommentieren>
  Serial.println("Spielfeld für die aktuelle Runde: ");
  printBoard(board, true);
  createBoard(abgefragt);
  createBoard(spannungswerte); // */

  // zum Überprüfen 
  spannungswerteSpeichern();
  Serial.println("Spannungswerte der Phototransistoren: ");
  printBoard(spannungswerte, false);
  delay(2048);
}
void loop() {
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.write("Du bist dran !");
  Serial.println("Du bist dran !");
  while (true) {
    tasterStatusEingabe = digitalRead(tasterEingabe); //Hier wird der Pin7 ausgelesen (Befehl:digitalRead). Das Ergebnis wird unter der Variable „tasterstatus“ mit dem Wert „HIGH“ für 5Volt oder „LOW“ für 0Volt gespeichert
    if (alleSchiffeVersenkt() == false) { //sind bereits alle Schiffe versenkt, kann man nicht weiterspielen
      if (tasterStatusEingabe == HIGH) { //Verarbeitung: Wenn der Taster gedrückt ist (Das Spannungssignal ist hoch)
        digitalWrite(gelbeLampePin, LOW);   //Lampen wieder ausschalten
        digitalWrite(roteLampePin, LOW);
        digitalWrite(blaueLampePin, LOW);
        check(); //check methode wird aufgerufen
        Serial.println("Spannungswerte der Phototransistoren: "); // zum Überprüfen
        printBoard(spannungswerte, false);         
        amountTrys += 1;                    //Zugzähler wird um 1 erhöht
        Serial.println("vom Spieler abgefragt:");
        printBoard(abgefragt, true);
        if (alleSchiffeVersenkt() == true) { //wenn alle Schiffe versenkt sind, blinken die LEDs
          digitalWrite(roteLampePin, LOW); //rote Lampe vom letzten versenkten Schiff ausschalten
          Serial.print("Anzahl Züge: "); // gibt die Anzahl der gebrauchten Spielzüge aus
          Serial.println(amountTrys);
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Du hast gewonnen");
          lcd.setCursor(0, 1);
          lcd.print("in " + String(amountTrys) + " Zuegen");
          while (true) {
            digitalWrite(blaueLampePin, HIGH); //Lichter blinken, wenn man gewonnen hat
            delay (blinkdauer);
            digitalWrite(blaueLampePin, LOW);
            digitalWrite(gelbeLampePin, HIGH);
            delay(blinkdauer);
            digitalWrite(gelbeLampePin, LOW);
            digitalWrite(roteLampePin, HIGH);
            delay(blinkdauer);
            digitalWrite(roteLampePin, LOW);
            digitalWrite(gelbeLampePin, HIGH);
            delay(blinkdauer);
            digitalWrite(gelbeLampePin, LOW);
          }
        }
        break;
      }
    }
  }
  botMove(botAsked);
  Serial.println("vom Bot abgefragt: ");
  printBoard(botAsked, false);
  if (shipsSunk[0] >= 2 && shipsSunk[1] >= 1 && shipsSunk[2] >= 1) { // falls alle Schiffe versenkt
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Du hast verloren :/");
    lcd.setCursor(0, 1);
    lcd.print("mit " + String(amountTrys) + " Zuegen");
    while (true) {
      digitalWrite(blaueLampePin, HIGH);
      delay(blinkdauer);
      digitalWrite(gelbeLampePin, HIGH);
      delay(blinkdauer);
      digitalWrite(blaueLampePin, LOW);
      digitalWrite(roteLampePin, HIGH);
      delay(blinkdauer);
      digitalWrite(gelbeLampePin, LOW);
      delay(blinkdauer);
      digitalWrite(roteLampePin, LOW);
      delay(blinkdauer);
    }
  }
  delay(2048);
}
// gibt das Spielbrett aus
void printBoard(int board[7][7], bool invertAxis) {
  for (int l = 1; l <= 5; l++) {
    for (int m = 1; m <= 5; m++) {
      if (!invertAxis)
        Serial.print(String(board[l][m]) + " ");
      else
        Serial.print(String(board[m][l]) + " ");
    }
    Serial.println();
  }
  Serial.println();
}
